<?php

//  Copyright (C) 2002-2006 Balint Kis (balint-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/import.php";
include_once "$theme/theme.php";

$session_id = $_COOKIE[$po_cookie];
if ($session_id == "") {
  header("location: login.php");
  exit();
}

include_once "include/common.php";
include_once "include/site.php";
include_once "include/exif.php";
include_once "include/color.php";
include_once "include/site.php";

$database = site_prolog();
$my_user_id = pg_fetch_row(pg_query($database, "select identifier, type from users where session_id='$session_id'"));
if ($my_user_id[1] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$current_folder  = $_REQUEST['folder'];

$users_location  = pg_query($database, "select identifier, country, state, city, place from view_location order by country, state, city, place");
$users_folder    = pg_query($database, "select identifier, caption, parent_folder from folder where users=$my_user_id[0] and caption!='Trash' and caption!='Orphanage'");
$users_camera    = pg_query($database, "select identifier, name, model, variation from view_camera where users=$my_user_id[0]");
$users_lens      = pg_query($database, "select identifier, name, model, variation, s_min_aperture, s_max_aperture, s_min_focal_length, s_max_focal_length from view_lens where users=$my_user_id[0]");
$users_film      = pg_query($database, "select identifier, name, model, iso       from view_film where users=$my_user_id[0]");
$users_flash     = pg_query($database, "select identifier, name, model, variation from view_flash where users=$my_user_id[0]");
$users_scanner   = pg_query($database, "select identifier, name, model, variation from view_scanner where users=$my_user_id[0]");
$users_filter    = pg_query($database, "select identifier, name, model, variation from view_filter where users=$my_user_id[0]");
$users_support   = pg_query($database, "select identifier, name, model, variation from view_support where users=$my_user_id[0]");

$aperture        = pg_query($database, "select identifier, value from aperture");
$focal_length    = pg_query($database, "select identifier, value from focal_length order by value");
$shutter         = pg_query($database, "select identifier, value from shutter");
$ev_comp         = pg_query($database, "select identifier, value from ev_comp");
$camera_metering = pg_query($database, "select identifier, value from camera_metering");
$camera_program  = pg_query($database, "select identifier, value from camera_program");
$flash_mode      = pg_query($database, "select identifier, value from flash_mode");
$scan_resolution = pg_query($database, "select identifier, value from scan_resolution");
$scan_bitdepth   = pg_query($database, "select identifier, value from scan_bitdepth");
$scan_multiscan  = pg_query($database, "select identifier, value from scan_multiscan");
$iso_override    = pg_query($database, "select identifier, value from film_iso order by value");

$user_name       = pg_fetch_row(pg_query($database, "select first_name, last_name, identifier from users where identifier=$my_user_id[0]"));
$folder          = pg_fetch_row(pg_query($database, "select caption from folder where identifier='$current_folder'"));
$my_preferences  = pg_fetch_row(pg_query($database, "
  select bulk_upload_enable, quota_size, quota_count
    from users, preferences
   where preferences.identifier=users.preferences
     and users.identifier=$my_user_id[0]"));


site_header($page_width, "Add Photo");
site_navigator(5, $my_user_id[1]);
$path_to_folder = get_path_to_folder($database, $current_folder);
site_navigator_status("<a href=user.php>Users</a> : <a href=\"user.php?user=$user_name[2]\">My Folders and Albums</a>$path_to_folder : <a href=folder.php?folder=$current_folder>$folder[0]</a> : Add photos", "");

print "&nbsp;<br/>\n";
print "<div align=\"center\" >\n";

// 0 means unlimited
if ($my_preferences[2] > 0) {
  $num_of_photo_versions = pg_fetch_row(pg_query($database, "select count_photo_versions_by_user($my_user_id[0])"));
  $num_of_photo_versions++;
  if ($my_preferences[2] <= $num_of_photo_versions[0]) {
    print "Your account have reached the photo quota of $my_preferences[2] photos including photo versions, imposed by your PO adminstrator.<br/>";
    print "No further uploads are possible.";
    print "</div>\n";
    print "&nbsp;<br/>\n";
    site_footer($database);
    site_epilog($database);
    exit();
  }
}

// 0 means unlimited
if ($my_preferences[1] > 0) {
  $used_storage_space = count_storage_space_by_user($database, $my_user_id[0]);
  if ($my_preferences[1] <= $used_storage_space) {
    $storage_quota = round($my_preferences[1]/1048576, 2);
    print "Your account have reached the storage space quota of $storage_quota Mb, imposed by your PO adminstrator.<br/>";
    print "No further uploads are possible.";
    print "</div>\n";
    print "&nbsp;<br/>\n";
    site_footer($database);
    site_epilog($database);
    exit();
  }
}

if (!ini_get("file_uploads")) {
  print "File upload is disabled in you PHP configuration file.<br/>";
  print "</div>\n";
  print "&nbsp;<br/>\n";
  site_footer($database);
  site_epilog($database);
}

$my_im_options = get_im_options($database, $my_user_id[0]);

if ($my_im_options[13] || $my_im_options[14]) {
  $color_name = get_color_name($my_im_options[15]);
  if ($color_name[0]=='a' || $color_name[0]=='e' || $color_name[0]=='o' || $color_name[0]=='i' || $color_name[0]=='u') {
    $color_name = "an " . $color_name;
  }
  else {
    $color_name = "a " . $color_name;
  }
  $thumb_decoration = ", decorated with <font style=\"background-color: #$my_im_options[15]\">$color_name</font> border of $my_im_options[13] x $my_im_options[14] pixels";
}

if ($my_im_options[5] || $my_im_options[6]) {
  $color_name = get_color_name($my_im_options[7]);
  if ($color_name[0]=='a' || $color_name[0]=='e' || $color_name[0]=='o' || $color_name[0]=='i' || $color_name[0]=='u') {
    $color_name = "an " . $color_name;
  }
  else {
    $color_name = "a " . $color_name;
  }
  $preview_decoration = ", decorated with <font style=\"background-color: #$my_im_options[7]\">$color_name</font> border of $my_im_options[5] x $my_im_options[6] pixels";
}

$my_im_composite_options = get_im_composite_options($database, $my_user_id[0]);

print "<table width=\"100%\"><tr><td align=\"center\" valign=\"middle\">";
if ($my_preferences[0] == 't') {
  print "Bulk upload is enabled.";
}
else {
  print "Bulk upload is disabled.";
}
print " The upload file size limit is: ".ini_get("upload_max_filesize").". The POST size limit is: ".ini_get("post_max_size").".<br/>";
print "A $thumb_max_size pixel thumbnail will be generated in the $my_im_options[9] color space, sharpened by $my_im_options[11] x $my_im_options[12] + $my_im_options[18] + $my_im_options[19], with $my_im_options[10] gamma correction$thumb_decoration and saved with quality $my_im_options[8].<br/>";
print "A $image_max_size pixel preview will be generated in the $my_im_options[1] color space, sharpened by $my_im_options[3] x $my_im_options[4] + $my_im_options[16] + $my_im_options[17], with $my_im_options[2] gamma correction$preview_decoration and saved with quality $my_im_options[0].<br/>";
if ($my_im_composite_options[1] > 0) {
  print "A watermark with brightness $my_im_composite_options[1]% will be applied in the $my_im_composite_options[0] region of the preview.<br/>";
  print "</td><td align=\"center\" valign=\"middle\">";
  print "Watermark<br/>";
  /* site_display_photo($database, $my_im_composite_options[2], true); */
  print "<a class=\"nodecor\" href=\"photo.php?photo=$my_im_composite_options[2]\"><img src=\"image.display.php?image=$my_im_composite_options[2]&amp;size=1\" alt=\"watermark\"></a>";
}
print "</td></tr></table>";

print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/select.js\"></script>";
print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/util.js\"></script>";
print "&nbsp;<br/>\n";
print "<form name=\"photoAdd\" method=\"post\" action=\"photo.add.2.php\" enctype=\"multipart/form-data\">\n";

print "<p>\n";
print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
print "<tr><td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"2\">File Selector</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">File</td>";
print "<td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<input type=file name=\"file_name[]\" size=\"60%\"></td></tr>";

if ($local_bulk_upload) {
  print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Local Path</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
  print "<input type=text name=\"local_path\" size=\"60%\"/></td></tr>";
}

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Into folder</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_folder_combo("folder", $users_folder, $current_folder, "");
print "</td></tr>\n";
print "</table>\n";

print "</p><p>\n";
print "<input type=\"image\" src=\"$theme/button.add.photos.gif\" border=\"0\" value=\"Add photos\">\n";
print "<a class=\"nodecor\" href=\"folder.php?folder=$current_folder\"><img src=\"$theme/button.cancel.gif\" border=\"0\" alt=\"Cancel\"></a>\n";
print "</p><p>\n";

print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
print "<tr><td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"2\">Metadata Import</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Import Precedence</td><td align=\"left\" valign=\"middle\" bgcolor=\"$color[table_body]\" >";
display_data_decoding_radio();
print "</td></tr>\n";
print "</table>\n";

print "</p><p>\n";
print "<input type=\"image\" src=\"$theme/button.add.photos.gif\" border=\"0\" value=\"Add photos\">\n";
print "<a class=\"nodecor\" href=\"folder.php?folder=$current_folder\"><img src=\"$theme/button.cancel.gif\" border=\"0\" alt=\"Cancel\"></a>\n";
print "</p><p>\n";

print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
print "<tr><td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"2\">Default Photo Properties</td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Title</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\"  name=\"title\" rows=\"2\" cols=\"60\"></textarea></td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Author</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\"  name=\"author\" rows=\"2\" cols=\"60\">$user_name[0] $user_name[1]</textarea></td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Keywords</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\"  name=\"keyword\" rows=\"3\" cols=\"60\"></textarea></td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Headline</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\"  name=\"headline\" rows=\"2\" cols=\"60\"></textarea></td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Caption Writer</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\"  name=\"caption_writer\" rows=\"2\" cols=\"60\"></textarea></td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Caption</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\"  name=\"caption\" rows=\"7\" cols=\"60\"></textarea></td></tr>\n";
print "</td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Category</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<input type=\"text\" name=\"category\" size=\"3\" title=\"Category\"></td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Supplemental Category</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\"  name=\"supplemental_category\" rows=\"7\" cols=\"60\"></textarea></td></tr>\n";
print "</td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Credit</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\"  name=\"credit\" rows=\"2\" cols=\"60\"></textarea></td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Copyright</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\"  name=\"copyright\" rows=\"2\" cols=\"60\">Copyright (c) " . date("Y") . " $user_name[0] $user_name[1]</textarea></td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Web Statement</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\"  name=\"web_statement\" rows=\"2\" cols=\"60\"></textarea></td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Instructions</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\"  name=\"instructions\" rows=\"2\" cols=\"60\"></textarea></td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Source</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\"  name=\"source\" rows=\"2\" cols=\"60\"></textarea></td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Transmission Refernce</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\"  name=\"transmission_reference\" rows=\"2\" cols=\"60\"></textarea></td></tr>\n";
print "</td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Exposure date</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_date_input_form("exposure_timestamp", "");
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Location</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_combo("location", $users_location, 0, ", ", 1);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Storage Location</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_storage_location_combo("storage_location_type", "");
print "<input type=\"text\" name=\"storage_location_id\" size=\"10\" title=\"Storage location identifier\"> - <input type=\"text\" name=\"storage_index\" size=\"4\" title=\"Storage location index\">";
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Access</td><td align=\"left\" valign=\"middle\" bgcolor=\"$color[table_body]\" >";
display_access_combo("access_rights", "t", "");
print "&nbsp;&nbsp;Original&nbsp;";
display_hide_original_combo("hide_original", "t");
print "</td></tr>\n";
print "</table>\n";

print "</p><p>\n";
print "<input type=\"image\" src=\"$theme/button.add.photos.gif\" border=\"0\" value=\"Add photos\">\n";
print "<a class=\"nodecor\" href=\"folder.php?folder=$current_folder\"><img src=\"$theme/button.cancel.gif\" border=\"0\" alt=\"Cancel\"></a>\n";
print "</p><p>\n";

print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
print "<tr><td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"2\">Default Shooting Data</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Camera</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_combo("camera", $users_camera, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Camera Metering</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("camera_metering", $camera_metering, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Camera Program</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("camera_program", $camera_program, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Lens</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_lens_combo("lens", $users_lens, 0, 0, 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Focal Length</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("focal_length", $focal_length, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Filter</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("filter", $users_filter, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Film</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("film", $users_film, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Film ISO Override</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("iso_override", $iso_override, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Aperture</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("aperture", $aperture, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Shutter Speed</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("shutter", $shutter, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Exposure Compensation</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("exp_comp", $ev_comp, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Ev Difference</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("exp_diff", $ev_comp, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Flash</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("flash", $users_flash, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Flash Mode</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("flash_mode", $flash_mode, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Flash Compensation</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("flash_comp", $ev_comp, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Colorspace</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_colorspace_combo("colorspace", 1);
print "</td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Scanner</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("scanner", $users_scanner, 0, "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Scan Parameters</td><td align=\"left\" valign=\"middle\" bgcolor=\"$color[table_body]\" >\n";
display_combo("scan_resolution", $scan_resolution, 0, "", 0);
print "dpi &nbsp;\n";
display_combo("scan_bitdepth", $scan_bitdepth, 0, "", 0);
print "bits &nbsp;\n";
display_combo("scan_multiscan", $scan_multiscan, 0, "", 0);
print "passes &nbsp;\n";
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\"  width=\"25%\">Support</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("support", $users_support, 0, "", 0);
print "</table>\n";

print "</p><p>\n";
print "<input type=\"image\" src=\"$theme/button.add.photos.gif\" border=\"0\" value=\"Add photos\">\n";
print "<a class=\"nodecor\" href=\"folder.php?folder=$current_folder\"><img src=\"$theme/button.cancel.gif\" border=\"0\" alt=\"Cancel\"></a>\n";
print "</p>\n";
print "</form>\n";
print "</div>\n";

site_footer($database);
site_epilog($database);
?>
