<?php

//  Copyright (C) 2002-2006 Balint Kis (balint-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/orderby.php";
include_once "include/search.php";
include_once "include/site.php";
include_once "$theme/theme.php";

function generate_history_html($url, $current_offset, $limit, $proxy, $size) {
  if ($limit == "all")
    return "";

  if ($size < $limit)
    return "";

  /* compute current page */
  $current_page = floor($current_offset/$limit);
  $num_of_pages = floor($size/$limit);

  if ($size <= $limit)
    return "";

  if (($size % $limit) > 0)
    $num_of_pages++;

  /* compute first page */
  if ($current_page < $proxy)
    $first_page = 0;
  else
    $first_page = $current_page - $proxy;

  /* compute last page */
  if (($current_page + $proxy + 1) > $num_of_pages)
    $last_page = $num_of_pages;
  else
    $last_page = $current_page + $proxy + 1;

  $html_string = "";
  if ($current_page > 0) {
    $this_offset = ($current_page - 1) * $limit;
    $html_string .= "<a class=\"nodecor\" href=\"$url&amp;limit=$limit&amp;offset=$this_offset\">Prev</a>&nbsp;";
  }

  if ($first_page != 0) {
    $html_string .= "<a class=\"nodecor\" href=\"$url&amp;limit=$limit&amp;offset=0\">1</a> ";
    if ($first_page != 1)
      $html_string .= "... ";
  }

  for ($page = $first_page; $page < $current_page; $page++) {
    $this_offset = $page * $limit;
    $this_page = $page + 1;
    $html_string .= "<a class=\"nodecor\" href=\"$url&amp;limit=$limit&amp;offset=$this_offset\">$this_page</a> ";
  }

  $this_page = $current_page + 1;
  $html_string .= "<a href=\"$url&amp;limit=$limit&amp;offset=$current_offset\"><b>$this_page</b></a> ";

  for ($page = $current_page + 1; $page < $last_page; $page++) {
    $this_offset = $page * $limit;
    $this_page = $page + 1;
    $html_string .= "<a class=\"nodecor\" href=\"$url&amp;limit=$limit&amp;offset=$this_offset\">$this_page</a> ";
  }

  if ($last_page != $num_of_pages) {
    if ($last_page != ($num_of_pages - 1))
      $html_string .= "... ";

    $this_offset = ($num_of_pages - 1) * $limit;
    $html_string .= "<a class=\"nodecor\" href=\"$url&amp;limit=$limit&amp;offset=$this_offset\">$num_of_pages</a> ";
  }

  if ($current_page < ($num_of_pages - 1)) {
    $this_offset = ($current_page + 1) * $limit;
    $html_string .= "&nbsp;<a class=\"nodecor\" href=\"$url&amp;limit=$limit&amp;offset=$this_offset\">Next</a> ";
  }

  return $html_string;
}

function display_sidebar_search_entry($database, $search_string, $search_type, $search_type_string, $current_user_id) {
  global $theme;

  $html_string = "&nbsp;<br/>";
  $html_string .= "<table align=\"center\" border=\"0\" width=\"100%\">";

  $html_string .= "<tr><td align=\"center\">";
  $html_string .= "<input type=\"text\" name=\"search_string\" value=\"$search_string\" style=\"width: 100%;\">";
  $html_string .= "</td></tr>";

  $html_string .= "<tr><td align=\"center\">";
  $html_string .= "<select onchange=\"location = this.options[this.selectedIndex].value;\" style=\"width: 100%;\">\n";
  for ($i = 0; $i < 3; $i++)
    if ($search_type == $i)
      $html_string .= "<option value=\"search.sidebar.php?search_type=$i\" selected>$search_type_string[$i]";
    else
      $html_string .= "<option value=\"search.sidebar.php?search_type=$i\">$search_type_string[$i]";
  $html_string .= "</select>";
  $html_string .= "<input type=\"hidden\" name=\"search_type\" value=\"$search_type\">";
  $html_string .= "</td></tr>";

  if ($search_type_string[$search_type] != "Users") {
    $html_string .= "<tr><td align=\"center\">";
    $html_string .= generate_html_users_combo("current_user", $database, $current_user_id, "style=\"width: 100%;\"");
    $html_string .= "</td></tr>";
  }

  $html_string .= "<tr><td align=\"center\">";
  $html_string .= "<input type=\"image\" src=\"$theme/button.search.gif\" border=\"0\" value=\"Search\">\n";
  $html_string .= "</td></tr>";
  $html_string .= "</table>";

  display_box_with_header("Type search string below", $html_string, "95%", "left");
}

$search_type_string = array ("Photos", "Folders", "Users");

$num_of_rows    = $default_num_of_rows_in_list_view;
$popup_enable   = $default_popup_enable;
$popup_delay    = $default_popup_delay;

$search_type    = $_REQUEST['search_type'];
$search_string  = $_REQUEST['search_string'];
$search_string  = validate_search_string($search_string);
$current_user_id = $_REQUEST['current_user'];
if (!$current_user_id || ($current_user_id=="all")) {
  $current_user_id = "null";
  $sql_photo_users_string = " ";
  $sql_folder_users_string = " ";
}
else {
  $sql_photo_users_string = " and photo.users = $current_user_id ";
  $sql_folder_users_string = " and folder.users = $current_user_id ";
}

$sql_query_order_by_string = $order_by_string[1][0];
$ignored_keywords = "";

$session_id    = $_COOKIE[$po_cookie];
$database      = site_prolog();
$my_user_id    = pg_fetch_row(pg_query($database, "select identifier, type from users where session_id='$session_id'"));
$offset        = $_REQUEST['offset'];
if (!$offset) {
  $offset = 0;
}

if ($my_user_id[0]!="") {
  $preferences = pg_fetch_row(pg_query($database, "
     select num_of_rows, popup_enable, popup_delay, search_enable_stemming
       from users, preferences
      where preferences.identifier=users.preferences
        and users.identifier=$my_user_id[0]"));
  $num_of_rows     = $preferences[0];
  $popup_enable    = $preferences[1];
  $popup_delay     = $preferences[2];
  $enable_stemming = $preferences[3];
}

site_head("Search");

$keywords = extract_keywords($search_string, $enable_stemming);

if (!$keywords) {
  print "<form action=\"search.sidebar.php\" method=\"post\">";
  display_sidebar_search_entry($database, $search_string, $search_type, $search_type_string, $current_user_id);
  print "</form>";

  if ($ignored_keywords != "") {
    $html_string = "&nbsp;<br/>";
    $html_string .= "<p>\n";
    $html_string .= "The following keywords were ignored: $ignored_keywords<br/>";
    $html_string .= "Use quotation marks to force the search engine to include these keywords.";
    $html_string .= "</p>\n";
    display_box_with_header("Search results", $html_string, "95%", "left");
  }

  print "&nbsp;<br/>";
  site_logo("center");
  site_credit("center", true, false);
  site_foot();
  site_epilog($database);
  exit();
}

switch ($search_type) {
 default:
 case 0: /* photo search */
   $status_string="Displaying photos";

   $sql_search_identifier = build_sql_search_string($keywords, "photo.identifier");
   $sql_search_title      = build_sql_search_string($keywords, "photo.title");
   $sql_search_author     = build_sql_search_string($keywords, "photo.author");
   $sql_search_keyword    = build_sql_search_string($keywords, "photo.keyword");
   $sql_search_caption    = build_sql_search_string($keywords, "photo.caption");
   $sql_search_place      = build_sql_search_string($keywords, "view_location.place");
   $sql_search_city       = build_sql_search_string($keywords, "view_location.city");
   $sql_search_state      = build_sql_search_string($keywords, "view_location.state");
   $sql_search_country    = build_sql_search_string($keywords, "view_location.country");

   $sql_search_combined_1 = "(".$sql_search_identifier." OR ".$sql_search_title ." OR ".$sql_search_author." OR ".$sql_search_keyword." OR ".$sql_search_caption.")";
   $sql_search_combined_2 = "(".$sql_search_identifier." OR ".$sql_search_title." OR ".$sql_search_author." OR ".$sql_search_keyword." OR ".$sql_search_caption." OR ".$sql_search_place." OR ".$sql_search_city." OR ".$sql_search_state." OR ".$sql_search_country.")";

   if ($my_user_id[0] == "") {
     $sql_query_access_rights_string = "photo.access_rights = $access[public]";
   }
   else {
     $sql_query_access_rights_string = "((photo.access_rights = $access[public]) or
                                         (photo.access_rights = $access[protected] and $my_user_id[0] in (select client from client where users=photo.users)) or
                                         (photo.users = $my_user_id[0]))";
   }


   /* query number of matches in a separate query, because the union might result duplicates */
   $num_of_matches_a = pg_fetch_row(pg_query($database, "
          select count(identifier) from photo where identifier in
         ((select photo.identifier
            from photo, folder, photo_dupe, photo_version, users
           where photo.folder = folder.identifier
             and photo.users = users.identifier
                 $sql_photo_users_string
             and photo.identifier = photo_version.photo
             and photo.identifier = photo_dupe.photo
             and photo_version.master='t'
             and photo_dupe.key = 1
             and ($sql_search_combined_1)
             and $sql_query_access_rights_string)
           union
         (select photo.identifier
            from photo, folder, photo_dupe, photo_version, users, view_location
           where photo.folder = folder.identifier
             and photo.users = users.identifier
                 $sql_photo_users_string
             and photo.identifier = photo_version.photo
             and photo.identifier = photo_dupe.photo
             and photo_version.master='t'
             and photo_dupe.key = 1
             and photo.location = view_location.identifier
             and ($sql_search_combined_2)
             and $sql_query_access_rights_string))"));

  $num_of_matches = $num_of_matches_a[0];

   $offset = $_REQUEST['offset'];
   if (!$offset) {
     $offset = 0;
   }

   $limit = $num_of_rows;
   if ($limit > $num_of_matches) {
     $limit = $num_of_matches;
   }

   $search_result = pg_query($database, "
         (select photo.identifier, photo_version.small_image_path, photo.caption, date_of_exposure, photo_dupe.date_of_creation,
                 (select value from access_type where access_type.identifier=photo.access_rights) as access_rights,
                 11 - (select avg(rating.value) from rating where rating.photo=photo.identifier) as rating,
                 views,
                 (0) as for_sale,
                 photo.title, photo.author, photo.keyword,
                 photo_version.original_image_name, photo.users
            from photo, folder, photo_dupe, photo_version, users
           where photo.folder = folder.identifier
             and photo.users = users.identifier
                 $sql_photo_users_string
             and photo.identifier = photo_version.photo
             and photo.identifier = photo_dupe.photo
             and photo_version.master='t'
             and photo_dupe.key = 1
             and ($sql_search_combined_1)
             and $sql_query_access_rights_string)
           union
         (select photo.identifier, photo_version.small_image_path, photo.caption, date_of_exposure, photo_dupe.date_of_creation,
                 (select value from access_type where access_type.identifier=photo.access_rights) as access_rights,
                 11 - (select avg(rating.value) from rating where rating.photo=photo.identifier) as rating,
                 views,
                 (0) as for_sale,
                 photo.title, photo.author, photo.keyword,
                 photo_version.original_image_name, photo.users
            from photo, folder, photo_dupe, photo_version, users, view_location
           where photo.folder = folder.identifier
             and photo.users = users.identifier
                 $sql_photo_users_string
             and photo.identifier = photo_version.photo
             and photo.identifier = photo_dupe.photo
             and photo_version.master='t'
             and photo_dupe.key = 1
             and photo.location = view_location.identifier
             and ($sql_search_combined_2)
             and $sql_query_access_rights_string)
           order by $sql_query_order_by_string
          offset $offset
           limit $limit");
    break;
 case 1: /* folder search */
   $status_string = "Displaying folders";
   $sql_search_string = build_sql_search_string($keywords, "folder.caption");
   if ($my_user_id[0] == "") {
     $sql_query_access_rights_string = "access_rights = $access[public]";
   }
   else {
     $sql_query_access_rights_string = "(users = $my_user_id[0] or access_rights = $access[public])";
   }

   $search_result = pg_query($database,
        "select caption, folder.identifier, date_of_creation,
                first_name, last_name, users.identifier
           from folder, users
          where $sql_search_string
                $sql_folder_users_string
            and $sql_query_access_rights_string
            and users.identifier = folder.users
          order by caption");
   $num_of_matches = pg_num_rows($search_result);
   break;
 case 2: /* user search */
   $status_string = "Displaying users";

   $sql_search_string = "(".
     build_sql_search_string($keywords, "last_name")." OR ".
     build_sql_search_string($keywords, "first_name")." OR ".
     build_sql_search_string($keywords, "username").")";

   $search_result = pg_query($database,
         "select identifier, first_name, last_name, member_since
            from users
           where ($sql_search_string)
             and type > $user_type[client]
           order by last_name, first_name");
   $num_of_matches = pg_num_rows($search_result);
}

if ($num_of_matches == 0) {
  print "<form action=\"search.sidebar.php\" method=\"post\">";
  display_sidebar_search_entry($database, $search_string, $search_type, $search_type_string, $current_user_id);
  print "</form>";

  $html_string = "&nbsp;<br/>";
  $html_string .= "<p>No matches found for <b>".$search_string."</b></p>";

  if ($ignored_keywords != "") {
    $html_string .= "<p>\n";
    $html_string .= "The following keywords were ignored: $ignored_keywords<br/>";
    $html_string .= "Use quotation marks to force the search engine to include these keywords.";
    $html_string .= "</p>\n";
  }

  display_box_with_header("Search results", $html_string, "95%", "left");
  print "&nbsp;<br/>";
  site_logo("center");
  site_credit("center", true, false);
  site_foot();
  site_epilog($database);
  exit();
}

$itemized_search_string = build_itemized_search_string($search_string, "search_string", "search_type=".$search_type."&");
print "<form action=\"search.sidebar.php\" method=\"post\">";
display_sidebar_search_entry($database, $search_string, $search_type, $search_type_string, $current_user_id);
print "</form>";

$html_string = "&nbsp;<br/>";
if ($ignored_keywords != "") {
  $html_string .= "<p>\n";
  $html_string .= "The following keywords were ignored: $ignored_keywords<br/>";
  $html_string .= "Use quotation marks to force the search engine to include these keywords.";
  $html_string .= "</p>\n";
}

switch ($search_type) {
 default:
 case 0: /* photo search */
   $arguments = "&search_type=$search_type";
   $search_string_exp = str_replace(" ", "+", $search_string);

   print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/select.js\"></script>";
   print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/util.js\"></script>";

   print "<form  name=\"photoList\" method=\"post\" action=\"folder.content.php\">";
   print "<input type=\"hidden\" name=\"user\" value=\"$user_id\">";
   print "<input type=\"hidden\" name=\"return\" value=\"search.sidebar.php?search_string=$search_string$arguments\">";
   print "<input type=\"hidden\" name=\"view\" value=\"$view\">";

   if (($offset + $limit) > $num_of_matches) {
     $photo_count = $num_of_matches - $offset;
   }
   else {
     $photo_count = $limit;
   }

   $html_string .= "<p align=\"right\">";
   $html_string .= generate_history_html($site_url . "/search.sidebar.php?search_type=$search_type&amp;search_string=$search_string", $offset, $limit, 2, $num_of_matches);
   $html_string .= "</p>";

/*    for ($i = 0; $i < $photo_count; $i++) { */
/*      $photo = pg_fetch_row($search_result, $i); */
/*      $photo[2] = makeZanza($photo[2], "No caption"); */
/*      if ($photo[8] == 1) */
/*        $html_string .= "<p>".($i + 1).". <a href=\"folder.php?folder=$photo[0]\">$photo[9]</a><br />\n"; */
/*      else { */
/*        $on_mouse_over ="t_w=10; ttWidth=10; return escape('<img src=image.display.php?image=$photo[0]&amp;size=1 border=0>')"; */
/*        $html_string .= "<p>".($i + 1 + $offset).". <a href=\"photo.php?photo=$photo[0]\" onmouseover=\"$on_mouse_over\">$photo[2]</a><br />\n"; */
/*      } */

/*      $html_string .= "&nbsp;&nbsp;&nbsp;&nbsp;Author: $photo[10]</p>\n"; */
/*    } */

   for ($i = 0; $i < $photo_count; $i++) {
     $photo = pg_fetch_row($search_result, $i);
     $photo[3] = substr($photo[3], 0, 10);
     $photo[4] = substr($photo[4], 0, 10);
     $photo[2] = ereg_replace("\"", "&quot;", $photo[2]);
     $photo[2] = ereg_replace("'", "\'", $photo[2]);
     $photo[2] = ereg_replace("\n", "", $photo[2]);
     $photo[2] = ereg_replace("\r", "", $photo[2]);

     if ($popup_enable == 't') {
       $tt_id = "tt_img_$photo[0]";
       echo '<div class="hide_tooltip" id="', $tt_id ,'">',
         '<table cellpadding="0" cellspacing="2" width="100%">';
       print tooltip_row('Title:',    $photo[9]);
       print tooltip_row('Author:',   $photo[10]);
       print tooltip_row('Caption:',  $photo[2]);
       print tooltip_row('Keywords:', $photo[11]);
       print tooltip_row('Exposed:',  $photo[3]);
       print tooltip_row('Created:',  $photo[4]);
       print tooltip_row('Access:',   $photo[5]);
       if ($photo[6] > 0)
         print tooltip_row('Rating:',   round(11 - $photo[6], 3));
       print tooltip_row('Views:',    $photo[7]);
       echo '</table>', "\n",
         '</div>', "\n";
      }

      $html_string .= "<p align=\"center\"><a class=\"nodecor\" href=\"photo.php?photo=$photo[0]$option\" ";
      if ($popup_enable == 't') {
        $html_string .= "onmouseover=\"this.T_DELAY=$popup_delay; this.T_WIDTH=200; this.T_BORDERCOLOR='$color[tooltip_border]'; this.T_BGCOLOR='$color[tooltip_background]'; return escape(tooltip_text('$tt_id'))\"";
      }
      $html_string .= "><img src=\"image.display.php?image=$photo[0]&amp;size=1\"></a></p>\n";
   }

   $html_string .= "<p align=\"right\">";
   $html_string .= generate_history_html($site_url . "/search.sidebar.php?search_type=$search_type&amp;search_string=$search_string", $offset, $limit, 2, $num_of_matches);
   $html_string .= "</p>";

   display_box_with_header("<b>".$num_of_matches ."</b> photo".($num_of_matches>1 ? "s" : "")." found", $html_string, "95%", "left");

   print "</form>";
   break;
 case 1: /* folder search */
   $folder_count = pg_num_rows($search_result);
   for ($i=0; $i < $folder_count; $i++) {
     $folder = pg_fetch_row($search_result, $i);
     $photos_by_folder = pg_fetch_row(pg_query($database, "select count_photos_by_folder($folder[1])"));
     $html_string .= "<p>".($i + 1).". <a href=\"folder.php?folder=$folder[1]\">$folder[0]</a><br />";
     $html_string .= "&nbsp;&nbsp;&nbsp;&nbsp;Owner: <a href=\"user.php?user=$folder[5]\">$folder[3] $folder[4]</a><br />";
     $html_string .= "&nbsp;&nbsp;&nbsp;&nbsp;Contains $photos_by_folder[0] photos</p>";
   }

   display_box_with_header("<b>".$folder_count ."</b> folder".($folder_count>1 ? "s" : "")." found", $html_string, "95%", "left");
   break;
 case 2: /* user search */
   $user_count = pg_num_rows($search_result);
   for ($i=0; $i < $user_count; $i++) {
     $user = pg_fetch_row($search_result, $i);
     $html_string .= "<p>".($i + 1).". <a href=\"user.php?user=$user[0]\">$user[1], $user[2]</a><br />";
     $html_string .= "&nbsp;&nbsp;&nbsp;&nbsp;Member since: ".generate_date_html($user[3], 'date', 0). "</p>";
   }
   display_box_with_header("<b>".$user_count ."</b> user".($user_count>1 ? "s" : "")." found", $html_string, "95%", "left");
}

print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/wz_tooltip.js\"></script>";
print "&nbsp;<br/>";
site_logo("center");
site_credit("center", true, false);
site_foot();
site_epilog($database);
?>
