
--  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.

--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.

--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

----------------------------------------------------------
-- v2.15 to v2.16 patch
----------------------------------------------------------

-- this function will concatenate two strings
-- the difference from the || operator is that our function
-- will ignore null arguments
create function concat_ignore_null(varchar, varchar) returns varchar as '
    declare
        string_1         alias for $1;
        string_2         alias for $2;
    begin
        if string_1 is null then
           return string_2;
        end if;

        if string_2 is null then
           return string_1;
        end if;

        return string_1||string_2;
     end;
' language  'plpgsql' ;

-- concat operator that ignores null arguments
create operator ||| (
  leftarg   = varchar,
  rightarg  = varchar,
  procedure = concat_ignore_null
);


alter table preferences add search_enable_stemming char(1) check (search_enable_stemming in ('t', 'f'));
alter table preferences add search_default_mode  integer;
